; TurboCNC 4.0 program to cut circles
M97 O9000												;Jump to the main program


; *** Subroutine to cut the circle ***
N0100 #1005=[#1005+#1004]           ;Increment the angle
#1006=[#1000+(#1002/2)*COS(#1005)]  ;compute new X position
#1007=[#1001+(#1002/2)*SIN(#1005)]  ;compute new Y position
G01 X#1006 Y#1007                   ;make the cut
IF #1005 LT 360 M97 O0100           ;Jump if circle not complete
M99                                 ;return from subroutine


; *********************************
; *         Main Program          *
; *********************************
;Parameters for the circle
N9000 #1000=2			    ;X-coord of center (inches)
#1001=1			            ;Y-Coord of center (inches)
#1002=1                             ;Diameter of the circle (inches)
#1003=360                           ;# of steps for a full circle

;computed variables
#1004=0                             ;delta (angular increment)
#1005=0                             ;theta (current angle)
#1006=0                             ;next X position
#1007=0                             ;next Y position                 

;setup
F20				    ;set feedrate
#1004=[360/#1003]                   ;compute theta (TurboCNC 4.0 
                                    ; trig functions are in degrees)
#1006=[#1000+(#1002/2)*COS(#1005)]  ;compute starting X position
#1007=[#1001+(#1002/2)*SIN(#1005)]  ;compute starting Y position
G00 X#1006 Y#1007                   ;traverse to start position
G01 Z2                              ;lower Z-axis to make cut
N9100 M98 O0100 		    ;jump to cutting subroutine 
G01 Z4                              ;retract Z-Axis
M02                                 ;End of program - circle 
